# DelPhi4Py

A python wrapper for the Poisson-Boltzmann Equation solver DelPhi

## Dependencies

- python3.5>=
- NumPy>=1.15.0

### DelPhi compilation dependencies

- gfortran #7.4.0
- gcc #7.4.0
- g++ #7.4.0
- libgfortran4

## Recipe to install GCC and GFortran 7.4

yum install glibc-static libgfortran-static

yum install wget
wget http://ftp.gnu.org/gnu/gcc/gcc-7.4.0/gcc-7.4.0.tar.gz
tar -xzf gcc-7.4.0.tar.gz
cd gcc-7.4.0
./contrib/download_prerequisites
mkdir build
cd build
../configure --prefix=/usr/local/gcc-7.4 --enable-languages=fortran --disable-multilib
make -j$(nproc)
sudo make install
export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/usr/local/gcc-7.4/lib64/

## Python specific

for i in 6 7
do
    python3.$i -m pip install numpy
done

for i in 8 9 10 11
do
    python3.$i -m pip install "setuptools<65" 
    python3.$i -m pip install "numpy<1.26"
done

for i in 12 13
do
    python3.$i -m pip install numpy meson ninja
done

## Compilation

Before running the `compile.sh` script please check that the compiler paths exist and correspond to version 7

```bash
bash compile.sh
```
To check for a correct compilation please run the script `test.py` on delphi4py/example/ and see a "successful exit" message
```bash
cd example/; python3 test.py
```

## License

DelPhi4Py itself is distributed under a LGPL-3.0, however, DelPhi is
proprietary software. To use DelPhi the user is required to download the DelPhi license [here](https://honiglab.c2b2.columbia.edu/software/cgi-bin/software.pl?input=DelPhi)